{$mode objfpc}{$assertions on}{$R+}
const
  P = 5;
type
  TAnyPlayer = 1..2 * P;
  TEvent = record time: Cardinal; attacker, victim: TAnyPlayer; killed: 0..1; end;
var
  attacks: array [TAnyPlayer, TAnyPlayer] of Cardinal;

  function IsGank(victim: Cardinal): Boolean;
  var
    attacker, j: TAnyPlayer;
  begin
    for attacker in TAnyPlayer do begin
      if attacks[attacker][victim] = 0 then begin
        if attacks[victim][attacker] > 0 then exit(false);
        continue;
      end;
      for j in TAnyPlayer do
        if (j <> victim) and
          ((attacks[attacker][j] > 0) or (attacks[j][attacker] > 0))
        then
          exit(false);
    end;
    Result := true;
  end;

var
  ganks, respawn: array [TAnyPlayer] of Cardinal;
  T: 1..100000;

  procedure CheckGank(var e: TEvent);
  var
    ganker: TAnyPlayer;
  begin
    if e.killed = 0 then exit;
    Assert(respawn[e.victim] < e.time);
    respawn[e.victim] := e.time + T;
    if not IsGank(e.victim) then exit;
    for ganker in TAnyPlayer do
      ganks[ganker] += Ord(attacks[ganker][e.victim] > 0);
  end;

var
  events: array of TEvent;
  i, t1, t2, t3: Cardinal;
  N: 1..10000;
  ganker: TAnyPlayer;
begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Read(N, T);
  SetLength(events, N);
  for i := 0 to High(events) do
    with events[i] do begin
      Read(time, attacker, victim, killed);
      Assert((attacker > P) <> (victim > P));
    end;
  Assert(SeekEof);
  t1 := 0;
  t2 := 0;
  while t2 <= High(events) do begin
    t3 := t2;
    while (t3 <= High(events)) and (events[t3].time = events[t2].time) do begin
      attacks[events[t3].attacker][events[t3].victim] += 1;
      t3 += 1;
    end;
    while events[t2].time - events[t1].time >= T do begin
      attacks[events[t1].attacker][events[t1].victim] -= 1;
      t1 += 1;
    end;
    while t2 < t3 do begin
      CheckGank(events[t2]);
      t2 += 1;
    end;
  end;
  for ganker in TAnyPlayer do
    Write(ganks[ganker], ' ');
end.
